const axios = require("axios")

function transformToServerHost(endpoint, datasetTag) {
    if (endpoint == "") { return "" }
    indexCutOff = String(endpoint).includes("graphql") ? endpoint.indexOf("/graphql") : endpoint.length
    return String(endpoint).substring(0, indexCutOff) + "/dataset/details/" + datasetTag
}

class AccuridsPIDGenerator {
    constructor(gqlendpoint, apikey, datasetTag) {
        this.graphql = String(gqlendpoint)
        this.apikey = apikey
        this.datasetTag = String(datasetTag)
        // what does the server host field in the query do?
        // it seems strange that this is needed
        // we set it to the browser standard
        this.serverHost = transformToServerHost(this.graphql, this.datasetTag)
        this.axios = axios.create({
            baseURL: this.graphql,
            timeout: 5000,
            headers: {"Apikey": this.apikey}
        })
    }
    async ping() {
        return this.axios.post("", '{ \
            "query": "" \
        }').then(resp => {
            if (resp.status == 200) {
                return Promise.resolve(true)
            } else {
                return Promise.reject(false)
            }
        }).catch(() => {
            return Promise.reject(false)
        })
    }
    async createPIDS(count) {
        const query = "mutation GenerateReferenceEntities($count: Int!, $datasetTag: String!, $serverHost: String!) {generateReferenceEntities(count: $count datasetTag: $datasetTag serverHost: $serverHost) { uri __typename } }"
        const variables = {
            count,
            datasetTag: this.datasetTag,
            serverHost: this.serverHost
        }
        return this.axios.post("", JSON.stringify({
            operationName: "GenerateReferenceEntities",
            variables,
            query
        })).then(resp => {
            console.log(resp.data)
            const uris = []
            for (const gRE of resp.data.data.generateReferenceEntities) {
                uris.push(gRE.uri)
            }
            return Promise.resolve(uris)
        })
    }

}
module.exports = AccuridsPIDGenerator